Unit Main;
{ ========================================================================== }
{ =   Lynx Tecnologia Eletrnica Ltda.                                     = }
{ =   Projeto:   Windows 95 / E/S digital ISA           Data: 03/jun/1999  = }
{ =   Programa:  Teste do driver VESDD                                     = }
{ =   Mdulo:    Main                                                      = }
{ =   Autor:     Lauro                                                     = }
{ =   Descrio: Window principal do programa.                             = }
{ =   Verso:    1.0                                                       = }
{ ========================================================================== }

{-------------------------  Descrio da Interface  -------------------------}
Interface

Uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     StdCtrls, Buttons, Menus, ExtCtrls, ComCtrls;

{ ===================================================== }
{ =               Declarao de tipos                 = }
{ ===================================================== }

Type
  TMainForm = class(TForm)
    panBack     : TPanel;
    StatusBar   : TStatusBar;
    MainMenu    : TMainMenu;
    panControl  : TPanel;
    btOpen      : TBitBtn;
    btClose     : TBitBtn;
    btVersion   : TBitBtn;
    panTiControl: TPanel;
    panTest     : TPanel;
    panTiTest   : TPanel;
    Arquivo1    : TMenuItem;
    Sair1       : TMenuItem;
    btTestDIO: TBitBtn;
    Procedure FormCreate (Sender: TObject);
    Procedure FormClose (Sender: TObject; var Action: TCloseAction);
    Procedure btCloseClick (Sender: TObject);
    Procedure btOpenClick (Sender: TObject);
    Procedure btVersionClick (Sender: TObject);
    Procedure Sair1Click (Sender: TObject);
    procedure btTestDIOClick(Sender: TObject);
  private
    { Private declarations }
    fOpen   : boolean;          { Indica se o VxD foi carregado }
    Procedure FinalizaDriver;
    Procedure UpdateCommands;
  public
    { Public declarations }
  end;


{ ===================================================== }
{ =                Variveis globais                  = }
{ ===================================================== }

  Var MainForm: TMainForm;


{-------------------------  Descrio da Implementao ----------------------}
Implementation
  Uses VESDDapi, TestDIO;

{$R *.DFM}



{ ========================================================================== }
{ =                   Implementao do objeto TMainForm                    = }
{ ========================================================================== }

{---------------------------------- TMainForm: Trata criao do formulrio --}
Procedure TMainForm.FormCreate (Sender: TObject);
  Var i   : smallint;
      sAux: string;
begin
  fOpen    := false;
  UpdateCommands;
end;

{------------------------------- TMainForm: Trata fechamento do formulrio --}
Procedure TMainForm.FormClose (Sender: TObject; var Action: TCloseAction);
begin
  FinalizaDriver;
end;

{----------------------- TMainForm: Trata comando para fechar o driver VxD --}
Procedure TMainForm.btCloseClick (Sender: TObject);
begin
  FinalizaDriver;
  StatusBar.Panels.Items [1].Text := '';
  UpdateCommands;
end;

{--------------------- TMainForm: Trata comando para carregar o driver VxD --}
Procedure TMainForm.btOpenClick (Sender: TObject);
begin
  fOpen := VESDD_Open;
  UpdateCommands;
end;

{------------------------ TMainForm: Trata comando de teste do E/S digital --}
Procedure TMainForm.btTestDIOClick (Sender: TObject);
begin
  dlgTestDIO.ShowModal;
end;

{-------------- TMainForm: Trata comando para obter a verso do driver VxD --}
Procedure TMainForm.btVersionClick (Sender: TObject);
  Var Version: word;
begin
  Version := VESDD_GetVersion;
  StatusBar.Panels.Items [0].Text := 'VESDD ' + IntToStr (Version div 256) +
                                          '.' + IntToStr (Version mod 256);
end;

{---------------------------------------- TMainForm: Finaliza o driver VxD --}
Procedure TMainForm.FinalizaDriver;
begin
  if  fOpen
  then begin
    VESDD_Close;
    fOpen    := false;
  end;
end;

{----------------------------------------- TMainForm: Finaliza a aplicao --}
Procedure TMainForm.Sair1Click (Sender: TObject);
begin
  Close;
end;

{------------------------------ TMainForm: Atualiza habilitao dos botes --}
Procedure TMainForm.UpdateCommands;
begin
  btOpen.Enabled    := not fOpen;
  btClose.Enabled   := fOpen;
  btTestDIO.Enabled := fOpen;
  btVersion.Enabled := fOpen;
end;

end.
