Unit TestDIO;
{ ========================================================================== }
{ =   Lynx Tecnologia Eletronica Ltda.                                     = }
{ =   Projeto:   Windows 95 / E/S digital ISA           Data: 03/jun/1999  = }
{ =   Programa:  Teste do driver VESDD                                     = }
{ =   Modulo:    TestDIO                                                   = }
{ =   Autor:     Lauro                                                     = }
{ =   Descricao: Teste da E/S Digital.                                     = }
{ =   Versao:    1.0                                                       = }
{ ========================================================================== }

{-------------------------  Descrio da Interface  -------------------------}
Interface

Uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     StdCtrls, ExtCtrls, Buttons, Spin;


{ ===================================================== }
{ =               Declarao de tipos                 = }
{ ===================================================== }

Type
  TdlgTestDIO = class(TForm)
    btClose        : TBitBtn;
    gbDigitalIput  : TGroupBox;   {-- Group box de Entrada Digital --}
    btReadDI       : TBitBtn;
    lblValDI       : TLabel;
    panReadDI      : TPanel;
    gbDigitalOutput: TGroupBox;
    btWriteDO      : TBitBtn;
    edWriteDO      : TEdit;
    lblValDO       : TLabel;
    gbLoopTest     : TGroupBox;   {-- Group box do Loop Test --}
    btLoopStart    : TBitBtn;
    btLoopStop     : TBitBtn;
    lblLoopDI      : TLabel;
    lblLoopDO      : TLabel;
    panLoopDI      : TPanel;
    panLoopDO      : TPanel;
    tmrLoop        : TTimer;
    sePortDI       : TSpinEdit;
    lblPortDI      : TLabel;
    lblPortDO      : TLabel;
    sePortDO       : TSpinEdit;
    ckByte         : TCheckBox;
    cbBaseAddr     : TComboBox;
    lblBaseAddr    : TLabel;
    Procedure FormCreate (Sender: TObject);
    Procedure FormClose (Sender: TObject; var Action: TCloseAction);
    Procedure btLoopStartClick (Sender: TObject);
    Procedure btLoopStopClick (Sender: TObject);
    Procedure btReadDIClick (Sender: TObject);
    Procedure btWriteDOClick (Sender: TObject);
    Procedure cbBaseAddrChange (Sender: TObject);
    Procedure tmrLoopTimer (Sender: TObject);
  private
    { Private declarations }
    BaseAddr: word;    { Endereo base da placa }
    vDO     : word;    { Valor da saida digital no Loop Test }
    Estado  : word;
    rgDI    : word;    { Nmero do port de entrada }
    rgDO    : word;    { Nmero do port de sada }
  public
    { Public declarations }
  end;

{ ===================================================== }
{ =                Variveis globais                  = }
{ ===================================================== }

  Var dlgTestDIO: TdlgTestDIO;


{-------------------------  Descricao da Implementao ----------------------}
Implementation
  Uses VESDDapi;

{$R *.DFM}

{ ===================================================== }
{ =           Constantes e variveis locais           = }
{ ===================================================== }

  Const
    cNBaseAddr = 4;
    cTabBaseAddr: array  [0..cNBaseAddr-1] of word =
                  ($300, $310, $350, $380);

{ ========================================================================== }
{ =                  Implementao do objeto TdlgTestDIO                   = }
{ ========================================================================== }

{------------------------------------------ TdlgTestDIO: Cria o dialog box --}
Procedure TdlgTestDIO.FormCreate (Sender: TObject);
  Var i: smallint;
begin
  {-- Inicia combo box com opes de endereo da placa ISA --}
  cbBaseAddr.Clear;
  for  i := 0 to Pred (cNBaseAddr)  do
    cbBaseAddr.Items.Add (Format ('%.3x', [cTabBaseAddr [i]]));
  cbBaseAddr.ItemIndex := 0;
  btLoopStop.Enabled   := false;
  tmrLoop.Enabled      := false;
  edWriteDO.Text       := '0';
  sePortDI.Value       := 0;
  sePortDO.Value       := 0;
  BaseAddr := cTabBaseAddr [cbBaseAddr.ItemIndex];
end;

{----------------------- TdlgTestDIO: Trata fechamento da caixa de dilogo --}
Procedure TdlgTestDIO.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  btReadDI.Enabled   := true;
  btWriteDO.Enabled  := true;
  sePortDI.Enabled   := true;
  sePortDO.Enabled   := true;
  ckByte.Enabled     := true;
  btLoopStop.Enabled := false;
  tmrLoop.Enabled    := false;
  edWriteDO.Text     := '0';
end;

{------------------------------------------ TdlgTestDIO: Trata boto Start --}
Procedure TdlgTestDIO.btLoopStartClick (Sender: TObject);
begin
  cbBaseAddr.Enabled  := false;
  btReadDI.Enabled    := false;
  btWriteDO.Enabled   := false;
  sePortDI.Enabled    := false;
  sePortDO.Enabled    := false;
  ckByte.Enabled      := false;
  btLoopStart.Enabled := false;
  btLoopStop.Enabled  := true;
  tmrLoop.Enabled     := true;
  tmrLoop.Interval    := 500;
  rgDI   := sePortDI.Value + BaseAddr;
  rgDO   := sePortDO.Value + BaseAddr;
  vDO    := 1;
  Estado := 0;
end;

{------------------------------------------- TdlgTestDIO: Trata boto Stop --}
Procedure TdlgTestDIO.btLoopStopClick (Sender: TObject);
begin
  cbBaseAddr.Enabled  := true;
  btReadDI.Enabled    := true;
  btWriteDO.Enabled   := true;
  sePortDI.Enabled    := true;
  sePortDO.Enabled    := true;
  ckByte.Enabled      := true;
  btLoopStart.Enabled := true;
  btLoopStop.Enabled  := false;
  tmrLoop.Enabled     := false;
end;

{---------------------------------------- TdlgTestDIO: Trata boto Read DI --}
Procedure TdlgTestDIO.btReadDIClick (Sender: TObject);
  Var Value: word;
begin
  rgDI  := sePortDI.Value + BaseAddr;
  if  ckByte.Checked  then
    Value := VESDD_ReadDI_Byte (rgDI)
  else
    Value := VESDD_ReadDI (rgDI);
  panReadDI.Caption := Format ('$%.4x', [Value]);
end;

{--------------------------------------- TdlgTestDIO: Trata boto Write DO --}
Procedure TdlgTestDIO.btWriteDOClick (Sender: TObject);
  Var Valor: word;
begin
  try
    rgDO  := sePortDO.Value + BaseAddr;
    Valor := StrToInt (edWriteDO.Text);
    if  ckByte.Checked  then
      VESDD_WriteDO_Byte (rgDO, Valor)
    else
      VESDD_WriteDO (rgDO, Valor);
  except
    on EConvertError do
      begin
        MessageDlg ('Valor invlido!', mtError, [mbOK], 0);
        ActiveControl := edWriteDO;
      end;
    on ERangeError do
      begin
        MessageDlg ('Valor fora da faixa!', mtError, [mbOK], 0);
        ActiveControl := edWriteDO;
      end;
  end;
end;

{-------------------- TdlgTestDIO: Trata mudana do endereo base da placa --}
Procedure TdlgTestDIO.cbBaseAddrChange (Sender: TObject);
begin
  BaseAddr := cTabBaseAddr [cbBaseAddr.ItemIndex];
end;

{---------------- TdlgTestDIO: Atualiza sada digital e l entrada digital --}
Procedure TdlgTestDIO.tmrLoopTimer (Sender: TObject);
  Var vDI: word;
begin
  panLoopDO.Caption := Format ('$%.4x', [vDO]);
  if  ckByte.Checked
  then begin
    VESDD_WriteDO_Byte (rgDO, vDO);
    vDI := VESDD_ReadDI_Byte (rgDI);
  end
  else begin
    VESDD_WriteDO (rgDO, vDO);
    vDI := VESDD_ReadDI (rgDI);
  end;
  panLoopDI.Caption := Format ('$%.4x', [vDI]);
  case  Estado  of
    0: begin
         vDO := vDO shl 1;
         if  vDO = 0
         then begin
           Inc (Estado);
           vDO := $aaaa;
         end;
       end;
    1..10:
        begin
          vDO := not vDO;
          Inc (Estado);
        end;
    11: begin
          vDO := $fffe;
          Inc (Estado);
        end;
    12: begin
          vDO := not (not (vDO) shl 1);
          if  vDO = $ffff
          then begin
            Inc (Estado);
            vDO := 0;
            tmrLoop.Interval := 10;
          end;
        end;
    13: begin
          if  vDO <> $ffff  then
            Inc (vDO)
          else begin
            tmrLoop.Interval := 500;
            Estado := 0;
            vDO    := 1;
          end;
        end;
    else ;
  end;
end;

end.
